<?php
/**
* NOTICE OF LICENSE.
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Permission is hereby granted, free of charge, to any person obtaining a copy of this software
* and associated documentation files (the "Software"), to deal in the Software without restriction,
* including without limitation the rights to use, copy, modify, merge, publish, distribute,
* sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all copies or substantial
* portions of the Software.
*
* The software is provided "as is", without warranty of any kind, express or implied including 
* but not limited to the warranties of merchantability, fitness for a particular purpose and
* noninfrigement. In no event shall the authors or copyright holdes be liable for any claim, 
* damages or the liability, whether in an action of contract, tort or otherwise, arising from, 
* out of or in connection with the software or the use or other dealings in the software.
*
* @author    Diabolo SARL <ecommerce@diazol.com>
* @copyright 2011 - 2016 Diabolo SARL
* @license   http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*/

class Semaphore
{
    private $lock_file;

    private $_fp;

    public function __construct()
    {
        $this->lock_file = dirname(__FILE__).'/../../../../arte-fact/outputs/ArtE_fact.lock';
    }

    public function isActive()
    {
        $result = file_exists($this->lock_file);

        if ($result) {
            $fp = fopen($this->lock_file, 'w+');
            if (flock($fp, LOCK_EX | LOCK_NB)) {
                $result = false;
            }
        }

        return $result;
    }

    public function active()
    {
        $this->_fp = fopen($this->lock_file, 'w+');
        flock($this->_fp, LOCK_EX);
        fwrite($this->_fp, getmypid());
    }

    public function deactive()
    {
        fclose($this->_fp);
        if (file_exists($this->lock_file)) {
            unlink($this->lock_file);
        }
    }
}
