<?php
/**
* NOTICE OF LICENSE.
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Permission is hereby granted, free of charge, to any person obtaining a copy of this software
* and associated documentation files (the "Software"), to deal in the Software without restriction,
* including without limitation the rights to use, copy, modify, merge, publish, distribute,
* sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all copies or substantial
* portions of the Software.
*
* The software is provided "as is", without warranty of any kind, express or implied including 
* but not limited to the warranties of merchantability, fitness for a particular purpose and
* noninfrigement. In no event shall the authors or copyright holdes be liable for any claim, 
* damages or the liability, whether in an action of contract, tort or otherwise, arising from, 
* out of or in connection with the software or the use or other dealings in the software.
*
* @author    Diabolo SARL <ecommerce@diazol.com>
* @copyright 2011 - 2016 Diabolo SARL
* @license   http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*/

require_once dirname(__FILE__).'/classes/semaphore.class.php';

$obj_semaphore = new Semaphore();

if (!$obj_semaphore->isActive()) {
	if (!defined('_PS_ADMIN_DIR_')) {
		define('_PS_ADMIN_DIR_', 'ADMIN');
	}

	require_once dirname(__FILE__).'/../../../config/config.inc.php';
	require_once dirname(__FILE__).'/classes/export_xml.class.php';

	$lang_id = Configuration::get('PS_LANG_DEFAULT');

	$obj_semaphore->active();

	$sqlQuery='';
	$maxOrderId=(int)Configuration::get('PS_ARF_MAX_ID_ORDER');
	if($maxOrderId>0) {
		$sqlQuery='po_o.id_order > '. $maxOrderId .' AND';
	}

	$sql='   SELECT po_o.id_order,
			 id_customer,
			 id_address_invoice,
			 id_address_delivery,
			 ps_ax.id_order AS id_order_exported 
	  FROM `' . _DB_PREFIX_ . 'orders` AS po_o
	  LEFT  JOIN `' . _DB_PREFIX_ . 'artefact_orders_export` AS ps_ax ON po_o.id_order = ps_ax.id_order
	  WHERE  '. $sqlQuery .' po_o.valid="1" AND ps_ax.id_order IS NULL ';

	$orders = Db::getInstance(_PS_USE_SQL_SLAVE_)->ExecuteS($sql);

	$obj_export_xml = new ExportXML();
	$obj_export_xml->setLangID($lang_id);

	foreach ($orders as $order) {
		$obj_export_xml->setOrderID((int)$order['id_order']);
		$obj_export_xml->setCustomerID((int)$order['id_customer']);
		$obj_export_xml->setInvoiceAddressID((int)$order['id_address_invoice']);
		$obj_export_xml->setDeliveryAddressID((int)$order['id_address_delivery']);
		$obj_export_xml->saveXML();

		Db::getInstance()->Execute('INSERT INTO '._DB_PREFIX_.'artefact_orders_export (id_order, order_is_exported)
								  VALUES('.(int)$order['id_order'].', 1)');
	}

	$obj_semaphore->deactive();
}

function pp($arg) {
	echo '<pre>';
	print_r($arg);
	echo '</pre>';
}
