<?php
/**
* NOTICE OF LICENSE.
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Permission is hereby granted, free of charge, to any person obtaining a copy of this software
* and associated documentation files (the "Software"), to deal in the Software without restriction,
* including without limitation the rights to use, copy, modify, merge, publish, distribute,
* sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all copies or substantial
* portions of the Software.
*
* The software is provided "as is", without warranty of any kind, express or implied including 
* but not limited to the warranties of merchantability, fitness for a particular purpose and
* noninfrigement. In no event shall the authors or copyright holdes be liable for any claim, 
* damages or the liability, whether in an action of contract, tort or otherwise, arising from, 
* out of or in connection with the software or the use or other dealings in the software.
*
* @author    Diabolo SARL <ecommerce@diazol.com>
* @copyright 2011 - 2016 Diabolo SARL
* @license   http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*/

class ArtifactPublication
{
    private $_logger;
    private $_default_category_id;

    public function __construct()
    {
        $this->rootCategory();
        $log = new ArtifactImport();
        if (isset($log->logger)) {
            $this->_logger = $log->logger;
        }
    }

    private function rootCategory()
    {
        $query = 'SELECT id_category FROM '._DB_PREFIX_.'category WHERE is_root_category= 1';
        if ($id_category = Db::getInstance()->getValue($query)) {
            $this->_default_category_id = $id_category;
        }

        if (Db::getInstance()->getMsgError()) {
            if (isset($this->_logger)) {
                $this->_logger->logInfo('SQL ERROR  CLASS PUBLICATION : SELECT CATEGORY FUNCTION rootCategory', Db::getInstance()->getMsgError());
            }
        }
    }

    public function isActiveProduct($id_product)
    {
		$unsetActive=false;
        $query1 = 'SELECT CONCAT(`description`, `description_short`) FROM '._DB_PREFIX_.'product_lang WHERE id_product="'.$id_product.'" AND id_lang="'.Configuration::get('PS_LANG_DEFAULT').'"';
        $query2 = 'SELECT id_image FROM '._DB_PREFIX_.'image WHERE id_product="'.$id_product.'" AND position=1';
        $result1 = Db::getInstance()->getValue($query1);
        $result2 = Db::getInstance()->getValue($query2);
        if (!empty($result1) && $result1 != '<p></p>') {
        	if(!empty($result2)) {
				return true;
        	}
        	else {
        		$unsetActive=true;
        	}
        } 
        if($unsetActive==true) {
            $query = 'UPDATE '._DB_PREFIX_.'product SET active=0 WHERE id_product="'.$id_product.'"';
            Db::getInstance()->Execute($query);
            if (Db::getInstance()->getMsgError()) {
                if (isset($this->_logger)) {
                    $this->_logger->logInfo('SQL ERROR  CLASS PUBLICATION : UPDATE PRODUCT FUNCTION isActiveProduct', Db::getInstance()->getMsgError());
                }
            }

            $query = 'UPDATE '._DB_PREFIX_.'product_shop SET active=0 WHERE id_product="'.$id_product.'"';
            Db::getInstance()->Execute($query);
            if (Db::getInstance()->getMsgError()) {
                if (isset($this->_logger)) {
                    $this->_logger->logInfo('SQL ERROR  CLASS PUBLICATION : UPDATE PRODUCT FUNCTION isActiveProduct', Db::getInstance()->getMsgError());
                }
            }
            return false;
        }
        if (Db::getInstance()->getMsgError()) {
            if (isset($this->_logger)) {
                $this->_logger->logInfo('SQL ERROR  CLASS PUBLICATION : SELECT IMAGE FUNCTION isActiveProduct', Db::getInstance()->getMsgError());
            }
        }

        return false;
    }

    public function isActiveStockProduct($id_product)
    {
        $query1 = 'SELECT quantity FROM '._DB_PREFIX_.'stock_available WHERE id_product="'.$id_product.'"';
        $result1 = Db::getInstance()->getValue($query1);
        if (!empty($result1) && $result1 >0) {
            return true;
        } else {
            $query = 'UPDATE '._DB_PREFIX_.'product SET active=0 WHERE id_product="'.$id_product.'"';
            Db::getInstance()->Execute($query);
            if (Db::getInstance()->getMsgError()) {
                if (isset($this->_logger)) {
                    $this->_logger->logInfo('SQL ERROR  CLASS PUBLICATION : UPDATE PRODUCT FUNCTION isActiveProduct', Db::getInstance()->getMsgError());
                }
            }

            $query = 'UPDATE '._DB_PREFIX_.'product_shop SET active=0 WHERE id_product="'.$id_product.'"';
            Db::getInstance()->Execute($query);
            if (Db::getInstance()->getMsgError()) {
                if (isset($this->_logger)) {
                    $this->_logger->logInfo('SQL ERROR  CLASS PUBLICATION : UPDATE PRODUCT FUNCTION isActiveProduct', Db::getInstance()->getMsgError());
                }
            }
            return false;
        }

        return false;
    }


    public function setActiveProduct($id_product)
    {
        $query = 'UPDATE `'._DB_PREFIX_.'product` SET `active`=1 WHERE `id_product`='.$id_product;
        Db::getInstance()->Execute($query);
        if (Db::getInstance()->getMsgError()) {
            if (isset($this->_logger)) {
                $this->_logger->logInfo('SQL ERROR  CLASS PUBLICATION : UPDATE PRODUCT FUNCTION setActiveProduct', Db::getInstance()->getMsgError());
            }
        }
        $query = 'UPDATE `'._DB_PREFIX_.'product_shop` SET `active`=1 WHERE `id_product`='.$id_product;
        Db::getInstance()->Execute($query);
        if (Db::getInstance()->getMsgError()) {
            if (isset($this->_logger)) {
                $this->_logger->logInfo('SQL ERROR  CLASS PUBLICATION : UPDATE PRODUCT FUNCTION setActiveProduct', Db::getInstance()->getMsgError());
            }
        }
    }

    public function isActiveCategorie($id_category)
    {
        $query = 'SELECT active FROM '._DB_PREFIX_.'category WHERE id_category='.$id_category;
        if ($active = Db::getInstance()->getValue($query)) {
            if (empty($active)) {
                return false;
            } elseif ($active == 1) {
                return true;
            } else {
                return 'noActive';
            }
        }
        if (Db::getInstance()->getMsgError()) {
            if (isset($this->_logger)) {
                $this->_logger->logInfo('SQL ERROR  CLASS PUBLICATION : SELECT CATEGORY FUNCTION isActiveCategorie', Db::getInstance()->getMsgError());
            }
        }

        return false;
    }

    public function setNoActiveProduct($id_product)
    {
        $query = 'UPDATE `'._DB_PREFIX_.'product` SET `active`=0 WHERE `id_product`='.$id_product;
        Db::getInstance()->Execute($query);
        if (Db::getInstance()->getMsgError()) {
            if (isset($this->_logger)) {
                $this->_logger->logInfo('SQL ERROR  CLASS PUBLICATION : UPDATE PRODUCT FUNCTION ', Db::getInstance()->getMsgError());
            }
        }
        $query = 'UPDATE `'._DB_PREFIX_.'product_shop` SET `active`=0 WHERE `id_product`='.$id_product;
        Db::getInstance()->Execute($query);
        if (Db::getInstance()->getMsgError()) {
            if (isset($this->_logger)) {
                $this->_logger->logInfo('SQL ERROR  CLASS PUBLICATION : UPDATE PRODUCT FUNCTION ', Db::getInstance()->getMsgError());
            }
        }
    }

    public function publicationActiveProducts()
    {
        $query = 'SELECT id_product FROM '._DB_PREFIX_.'product';
        if ($results = Db::getInstance()->ExecuteS($query)) {
            foreach ($results as $result) {
                if ($this->isActiveProduct($result['id_product']) == true) {
                    $this->setActiveProduct($result['id_product']);
                }
            }
        }
        if (Db::getInstance()->getMsgError()) {
            if (isset($this->_logger)) {
                $this->_logger->logInfo('SQL ERROR  CLASS PUBLICATION : SELECT PRODUCT FUNCTION publicationActiveProducts', Db::getInstance()->getMsgError());
            }
        }
    }

    public function publicationNonActiveProducts()
    {
        Db::getInstance()->Execute('UPDATE IGNORE `'._DB_PREFIX_.'product_shop` SET active = 1');
        if (Db::getInstance()->getMsgError()) {
            if (isset($this->_logger)) {
                $this->_logger->logInfo('SQL ERROR  CLASS PUBLICATION : UPDATE IGNORE PRODUCT FUNCTION publicationNonActiveProducts', Db::getInstance()->getMsgError());
            }
        }
    }


    public function publicationActiveStockProducts()
    {
        $query = 'SELECT id_product FROM '._DB_PREFIX_.'product';
        if ($results = Db::getInstance()->ExecuteS($query)) {
            foreach ($results as $result) {
                if ($this->isActiveStockProduct($result['id_product']) == true) {
                    $this->setActiveProduct($result['id_product']);
                }
            }
        }
        if (Db::getInstance()->getMsgError()) {
            if (isset($this->_logger)) {
                $this->_logger->logInfo('SQL ERROR  CLASS PUBLICATION : SELECT PRODUCT FUNCTION publicationActiveProducts', Db::getInstance()->getMsgError());
            }
        }
    }

    public function publicationNonActiveStockProducts()
    {
        Db::getInstance()->Execute('UPDATE IGNORE `'._DB_PREFIX_.'product_shop` SET active = 1');
        if (Db::getInstance()->getMsgError()) {
            if (isset($this->_logger)) {
                $this->_logger->logInfo('SQL ERROR  CLASS PUBLICATION : UPDATE IGNORE PRODUCT FUNCTION publicationNonActiveStockProducts', Db::getInstance()->getMsgError());
            }
        }
    }





    private function _setActiveCategorie($id_categorie)
    {
        $query = 'UPDATE '._DB_PREFIX_.'category SET active=1 WHERE id_category=\''.$id_categorie.'\'';
        Db::getInstance()->Execute($query);
        if (Db::getInstance()->getMsgError()) {
            if (isset($this->_logger)) {
                $this->_logger->logInfo('SQL ERROR  CLASS PUBLICATION : UPDATE CATEGORIE FUNCTION _setActiveCategorie', Db::getInstance()->getMsgError());
            }
        }
    }

    public function publicationActiveCategories()
    {
        Db::getInstance()->Execute('UPDATE IGNORE `'._DB_PREFIX_.'category` SET active = 0 WHERE id_category != 1 and id_category !=\''.$this->_default_category_id.'\'');
        if (Db::getInstance()->getMsgError()) {
            if (isset($this->_logger)) {
                $this->_logger->logInfo('SQL ERROR  CLASS PUBLICATION : UPDATE IGNORE CATEGORY FUNCTION publicationActiveCategories', Db::getInstance()->getMsgError());
            }
        }
        $query = 'SELECT DISTINCT `'._DB_PREFIX_.'category`.`id_category` FROM `'._DB_PREFIX_.'category`
				JOIN `'._DB_PREFIX_.'category_product` 
				ON `'._DB_PREFIX_.'category`.`id_category`=`'._DB_PREFIX_.'category_product`.`id_category`
				JOIN `'._DB_PREFIX_.'product_shop`
				ON `'._DB_PREFIX_.'product_shop`.`id_product`=`'._DB_PREFIX_.'category_product`.`id_product`
				AND  `'._DB_PREFIX_.'product_shop`.`active`=1';
        if ($results = Db::getInstance()->ExecuteS($query)) {
            foreach ($results as $result) {
                $this->_setActiveCategorie($result['id_category']);
                $this->setActiveParents($result['id_category']);
            }
        }
        if (Db::getInstance()->getMsgError()) {
            if (isset($this->_logger)) {
                $this->_logger->logInfo('SQL ERROR  CLASS PUBLICATION : SELECT CATEGORY, CATEGORY_PRODUCT ET PRODUCT FUNCTION publicationActiveCategories', Db::getInstance()->getMsgError());
            }
        }
    }

    private function setActiveParent($id_category)
    {
        if ($id_category == $this->_default_category_id) {
            return $id_category;
        }

        $query = 'SELECT P.`id_category` FROM `'._DB_PREFIX_.'category` C 
				JOIN `'._DB_PREFIX_.'category` P
				ON C.`id_parent` = P.`id_category` 
				AND C.`id_category`=\''.$id_category.'\'';

        if ($id_category = Db::getInstance()->getValue($query)) {
            $this->_setActiveCategorie($id_category);

            return $id_category;
        }

        if (Db::getInstance()->getMsgError()) {
            if (isset($this->_logger)) {
                $this->_logger->logInfo('SQL ERROR  CLASS PUBLICATION : UPDATE IGNORE CATEGORY FUNCTION setActiveParent', Db::getInstance()->getMsgError());
            }
        }
    }

    private function setActiveParents($id_category)
    {
        $id_parent = $this->setActiveParent($id_category);
        while ($id_parent != $id_category) {
            $id_category = $id_parent;
            $id_parent = $this->setActiveParent($id_category);
        }
    }

    public function publicationNonActiveCategories()
    {
        Db::getInstance()->Execute('UPDATE IGNORE `'._DB_PREFIX_.'category` SET active = 1');
        if (Db::getInstance()->getMsgError()) {
            if (isset($this->_logger)) {
                $this->_logger->logInfo('SQL ERROR  CLASS PUBLICATION : UPDATE IGNORE CATEGORY FUNCTION publicationNonActiveCategories', Db::getInstance()->getMsgError());
            }
        }
    }

    private function _setActiveBrand($id_manufacturer, $active)
    {
        $query = 'UPDATE '._DB_PREFIX_.'manufacturer SET active='.$active.' WHERE id_manufacturer=\''.$id_manufacturer.'\'';
        Db::getInstance()->Execute($query);
        if (Db::getInstance()->getMsgError()) {
            if (isset($this->_logger)) {
                $this->_logger->logInfo('SQL ERROR  CLASS PUBLICATION : UPDATE MANUFACTURER FUNCTION _setActiveBrand', Db::getInstance()->getMsgError());
            }
        }
    }

    public function publicationActiveBrands()
    {
        $sql = 'SELECT m.* 
		FROM `'._DB_PREFIX_.'manufacturer` m
		'.Shop::addSqlAssociation('manufacturer', 'm').'
		 ORDER BY m.`name` ASC';

        $manufacturers = Db::getInstance(_PS_USE_SQL_SLAVE_)->executeS($sql);

        foreach ($manufacturers as $key => $manufacturer) {
            $manufacturers[$key]['nb_products'] = Db::getInstance(_PS_USE_SQL_SLAVE_)->getValue('
			SELECT COUNT(DISTINCT p.`id_product`)
			FROM `'._DB_PREFIX_.'product` p
			'.Shop::addSqlAssociation('product', 'p').'
			WHERE p.`id_manufacturer` = '.(int)$manufacturer['id_manufacturer'].'
			AND product_shop.`visibility` NOT IN ("none")
			AND product_shop.`active` = 1 ');

            if ($manufacturers[$key]['nb_products'] > 0) {
                $this->_setActiveBrand($manufacturers[$key]['id_manufacturer'], 1);
            } else {
                $this->_setActiveBrand($manufacturers[$key]['id_manufacturer'], 0);
            }
        }
    }
}
