<?php
/**
* NOTICE OF LICENSE.
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Permission is hereby granted, free of charge, to any person obtaining a copy of this software
* and associated documentation files (the "Software"), to deal in the Software without restriction,
* including without limitation the rights to use, copy, modify, merge, publish, distribute,
* sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all copies or substantial
* portions of the Software.
*
* The software is provided "as is", without warranty of any kind, express or implied including 
* but not limited to the warranties of merchantability, fitness for a particular purpose and
* noninfrigement. In no event shall the authors or copyright holdes be liable for any claim, 
* damages or the liability, whether in an action of contract, tort or otherwise, arising from, 
* out of or in connection with the software or the use or other dealings in the software.
*
* @author    Diabolo SARL <ecommerce@diazol.com>
* @copyright 2011 - 2016 Diabolo SARL
* @license   http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*/

class Semaphore {

	private static $pid;

	function __construct() {}

	function __clone() {}

	private static function isrunning() {
		$pids = explode(PHP_EOL, `ps -e | awk '{print $1}'`);
		if(in_array(self::$pid, $pids)) {
			return true;
		}
		else {
			return false;
		}
	}

	public static function lock($logger) {

		$lock_file = _PS_ROOT_DIR_.'/arte-fact/inputs/ArtE_fact.lock';

		if(file_exists($lock_file)) {
			//return false;

			// Is running?
			self::$pid = file_get_contents($lock_file);
			if(self::isrunning()) {
				if(Configuration::get('PS_ARTIFACT_DEBUG')==true) {
					if(isset($logger)) {
						$logger->logInfo("==".self::$pid."== Already in progress...");
						$diffInMinutesSinceLockModified = round((time()-filemtime($lock_file))/60);
						$logger->logInfo("==".$diffInMinutesSinceLockModified."== since lock has been set...");
						if($diffInMinutesSinceLockModified>=30) {
							$templateVars = array();
							$templateVars['{filemtime_lock}'] = filemtime($lock_file);
							$templateVars['{time_running}'] = $diffInMinutesSinceLockModified;
							$templateVars['{shop_name}'] = Configuration::get('PS_SHOP_NAME');
							Mail::Send(
								(int)Language::getIdByIso('fr'), 
								'sync-locked', 
								Mail::l('Artifact Caisse Sync locked!'), 
								$templateVars, 
								"olivier@diazol.com", 
								" Olivier Le Brenn", 
								Configuration::get('PS_SHOP_EMAIL'), 
								Configuration::get('PS_SHOP_NAME'), 
								null, 
								null, 
								dirname(__FILE__).'/../../mails/'
							);
						}
					}
				}
				return false;
			}
			else {
				if(Configuration::get('PS_ARTIFACT_DEBUG')==true) {
					if(isset($logger)) {
						$logger->logInfo("==".self::$pid."== Previous job died abruptly...");
						$diffInMinutesSinceLockModified = round((time()-filemtime($lock_file))/60);
						$logger->logInfo("==".$diffInMinutesSinceLockModified."== since lock has been set...");
						if($diffInMinutesSinceLockModified>=30) {
							$templateVars = array();
							$templateVars['{filemtime_lock}'] = filemtime($lock_file);
							$templateVars['{time_running}'] = $diffInMinutesSinceLockModified;
							$templateVars['{shop_name}'] = Configuration::get('PS_SHOP_NAME');
							Mail::Send(
								(int)Language::getIdByIso('fr'), 
								'sync-locked', 
								Mail::l('Artifact Caisse Sync locked!'), 
								$templateVars, 
								"olivier@diazol.com", 
								" Olivier Le Brenn", 
								Configuration::get('PS_SHOP_EMAIL'), 
								Configuration::get('PS_SHOP_NAME'), 
								null, 
								null, 
								dirname(__FILE__).'/../../mails/'
							);
						}
					}
				}
				return false;
			}
		}
		else {
			self::$pid = getmypid();
			file_put_contents($lock_file, self::$pid);
			if(Configuration::get('PS_ARTIFACT_DEBUG')==true) {
				if(isset($logger)) 
					$logger->logInfo("==".self::$pid."== Lock acquired, processing the job...");
			}
			return self::$pid;
		}

	}

	public static function unlock($logger) {

		global $argv;

		$lock_file = _PS_ROOT_DIR_.'/arte-fact/inputs/ArtE_fact.lock';

		if(file_exists($lock_file))
			unlink($lock_file);

		if(Configuration::get('PS_ARTIFACT_DEBUG')==true) {
			if(isset($logger)) 
				$logger->logInfo("==".self::$pid."== Releasing lock...");
		}
		return true;
	}

}

?>