<?php
/**
* NOTICE OF LICENSE.
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Permission is hereby granted, free of charge, to any person obtaining a copy of this software
* and associated documentation files (the "Software"), to deal in the Software without restriction,
* including without limitation the rights to use, copy, modify, merge, publish, distribute,
* sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in all copies or substantial
* portions of the Software.
*
* The software is provided "as is", without warranty of any kind, express or implied including 
* but not limited to the warranties of merchantability, fitness for a particular purpose and
* noninfrigement. In no event shall the authors or copyright holdes be liable for any claim, 
* damages or the liability, whether in an action of contract, tort or otherwise, arising from, 
* out of or in connection with the software or the use or other dealings in the software.
*
* @author    Diabolo SARL <ecommerce@diazol.com>
* @copyright 2011 - 2016 Diabolo SARL
* @license   http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*/
ini_set('max_execution_time',600);

require_once(dirname(__FILE__) . '/classes/semaphore.class.php');
require_once(dirname(__FILE__) . '/../../../config/config.inc.php');
require_once(dirname(dirname(__FILE__)).'/vendors/KLogger.php');

$pid=$artifactLock=false;
$artifactLock=_exist();

$Directory    = _PS_ROOT_DIR_.'/arte-fact/logs/';
$logger=new Klogger($Directory,KLogger::DEBUG);


if($artifactLock==false) {

	$pid = Semaphore::lock($logger);

	if($pid!==false) {

		if (!defined('_PS_ADMIN_DIR_')) {
			define('_PS_ADMIN_DIR_', "ADMIN");
		}
		require_once(dirname(__FILE__).'/../../../images.inc.php');
		require_once(dirname(__FILE__) . '/classes/import.class.php');

        $objImport = new ArtifactImport();
		$objImport->runImport();

		Semaphore::unlock($logger);
	}
	else {
		$logger->logInfo('import can\'t run as it is alreay in progress');
	}
}
else {
	$logger->logInfo('import can\'t run as Artifact is currently uploading files');
}


function _exist(){

	$pixfiles = _PS_ROOT_DIR_.'/arte-fact/inputs/images/produits/lock';
	$xmlfiles = _PS_ROOT_DIR_.'/arte-fact/inputs/files_xml/lock';

	if(is_file($pixfiles))
		return true;
	elseif(is_file($xmlfiles))
		return true;
	else 
		return false;
	
}

function pp($arg) {
	echo '<pre>';
	print_r($arg);
	echo '</pre>';
}
